#include <stdio.h>
#include <sys/types.h>

#if !defined(i386_unknown_nt4_0)
#include <sys/time.h>
#else
#include <windows.h>
#endif /* !defined(i386_unknown_nt4_0) */


#include "thread/h/thread.h"

#define MILLION   1000000.0
#define NSWITCHES 10000


#if !defined(i386_unknown_nt4_0)
struct timeval tstart;
struct timeval tend;
#else
LARGE_INTEGER	tstart;
LARGE_INTEGER	tend;
#endif /* !defined(i386_unknown_nt4_0) */

unsigned nswitches = NSWITCHES;

double cslat;
double usecs;

static void*
foo(void* arg)
{
    unsigned i;

    for (i = 0; i < nswitches; i++) {
        thr_yield();
    }
    return 0;
}


int
main(int argc, char** argv)
{
    argv++; argc--;
    if (argc) { sscanf(*argv, "%d", &nswitches); argv++; argc--; }
    if (nswitches <= 0) { nswitches = NSWITCHES; }

    printf("%u context switch timings\n", nswitches);

    thr_create(0, 0, foo, 0, 0, 0);
    thr_create(0, 0, foo, 0, 0, 0);

#if !defined(i386_unknown_nt4_0)
	gettimeofday(&tstart, NULL);
#else
	QueryPerformanceCounter( &tstart );
#endif /* !defined(i386_unknown_nt4_0) */

    thr_join(0, 0, 0);
    thr_join(0, 0, 0);

#if !defined(i386_unknown_nt4_0)
    gettimeofday(&tend, NULL);
#else
	QueryPerformanceCounter( &tend );
#endif /* !defined(i386_unknown_nt4_0) */


	/* report our results */
#if !defined(i386_unknown_nt4_0)
	usecs = (tend.tv_sec * MILLION + tend.tv_usec) -
			(tstart.tv_sec * MILLION + tstart.tv_usec);
#else
	{
		LARGE_INTEGER freq;
		QueryPerformanceFrequency( &freq );

		usecs = MILLION * (((double)tend.QuadPart) - tstart.QuadPart)/freq.QuadPart;
	}
#endif /* !defined(i386_unknown_nt4_0) */
	cslat = usecs / (nswitches * 2.0);
	printf("switch latency: %g us\n", cslat);

    return 0;
}
